我是靠谱客的博主 落寞蜻蜓,最近开发中收集的这篇文章主要介绍leetcode python3 简单题1.Two Sum1.编辑器2.第一题,觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

1.编辑器

我使用的是win10+vscode+leetcode+python3
环境配置参见我的博客:
链接

2.第一题

(1)题目
英文:
Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.
中文:
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/valid-parentheses
(2)解法
① 使用enumerate(单循环)(耗时:1636ms,内存:14.5M)

class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
for indx, num in enumerate(nums):
if target - num in nums:
if indx == nums.index(target - num):
continue
return [indx, nums.index(target - num)]

注意:
1.如果nums=[3,4,5],target=6,那么第一个6-3=3是它本身,而不是两个不同数,所以要排除掉这种情况,否则无法AC,当然这个还有个大前提是,nums没有重复的元素哦。
2.list类型的.index只会返回第一个index,要想返回所有的index,使用:

[i for i in range(len(list)) if list[i] == 某个数]

3.twoSum(self, nums: List[int], target: int) -> List[int]:
这里只是对输入变量和函数输出值类型的说明,并不会提示报错。

② 使用enumerate(双循环)(耗时:5384ms,内存:14.6M)

class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
for indx1, num1 in enumerate(nums):
for indx2 in range(indx1+1, len(nums)):
if num1 + nums[indx2] == target:
return [indx1, indx2]

注意:
1.这种结构就显然过滤掉了①中注意1.中的情况了,相当于排列组合

③ 使用hash map(字典dict)(耗时: 64ms,内存:15M)

class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
hashmap = {}
for indx, num in enumerate(nums):
if target - num in hashmap:
return [indx, hashmap[target - num]]
hashmap[num] = indx

注意:
1.这种结构就显然也能过滤掉①中注意1.中的情况

本人现在的研究方向是:
图像的语义分割,如果有志同道合的朋友,可以组队学习
haiyangpengai@gmail.com qq:1355365561

最后

以上就是落寞蜻蜓为你收集整理的leetcode python3 简单题1.Two Sum1.编辑器2.第一题的全部内容,希望文章能够帮你解决leetcode python3 简单题1.Two Sum1.编辑器2.第一题所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(34)

评论列表共有 0 条评论

立即
投稿
返回
顶部